﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Malovani
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
            pictureBox_SizeChanged (null, null);
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Image last = pictureBox.Image;
            int w = pictureBox.Width;
            int h = pictureBox.Height;
            if (w > 0 && h > 0)
            {
               if (last != null)
               {
                   w = Math.Max (w, last.Width);
                   h = Math.Max (h, last.Height);
               }
               pictureBox.Image = new Bitmap (w, h);
               Graphics g = Graphics.FromImage (pictureBox.Image);
               Brush b = new SolidBrush (Color.White);
               g.FillRectangle(b, 0, 0, w, h);
               if (last != null)
                  g.DrawImage (last, 0, 0);
            }
        }

        private int X0, Y0;
        private bool pressed = false;
        private Bitmap save;

        private void pictureBox_MouseDown (object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            pressed = true;
            save = new Bitmap (pictureBox.Image);
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (pressed)
            {
                Graphics g = Graphics.FromImage (pictureBox.Image);
                g.DrawImage (save, 0, 0);
                Pen p = new Pen (Color.Red, 3);
                if (e.Button == MouseButtons.Left)
                    g.DrawLine(p, X0, Y0, e.X, e.Y);
                else if (e.Button == MouseButtons.Middle)
                {
                    int X1 = X0;
                    int Y1 = Y0;
                    int X2 = e.X;
                    int Y2 = e.Y;
                    if (X1 > X2) { int t = X1; X1 = X2; X2 = t; }
                    if (Y1 > Y2) { int t = Y1; Y1 = Y2; Y2 = t; }
                    g.DrawRectangle(p, X1, Y1, X2-X1, Y2-Y1);
                }
                else if (e.Button == MouseButtons.Right)
                    g.DrawEllipse(p, X0, Y0, e.X - X0, e.Y - Y0);
                pictureBox.Invalidate();
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            pressed = false;
        }


    }
}
